package eu.eudat.integrationevent.outbox.dmptouched;

import eu.eudat.model.persist.DmpPersist;

public interface DmpTouchedIntegrationEventHandler {

    void handle(DmpTouchedIntegrationEvent event);

    static DmpTouchedIntegrationEvent buildEventFromPersistModel(DmpPersist persist) {
        DmpTouchedIntegrationEvent event = new DmpTouchedIntegrationEvent();
        event.setId(persist.getId());
        event.setLabel(persist.getLabel());
        event.setStatus(persist.getStatus());
        event.setContacts(persist.getProperties().getContacts());
        event.setDmpBlueprintValues(persist.getProperties().getDmpBlueprintValues());
        event.setDescription(persist.getDescription());
        event.setLanguage(persist.getLanguage());
        event.setBlueprint(persist.getBlueprint());
        event.setAccessType(persist.getAccessType());
        event.setDescriptionTemplates(persist.getDescriptionTemplates());
        return event;
    }

}
