package eu.eudat.integrationevent.outbox.notification;

import eu.eudat.integrationevent.outbox.OutboxIntegrationEvent;
import eu.eudat.integrationevent.outbox.OutboxService;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.context.annotation.RequestScope;

import java.util.UUID;

@Component
@RequestScope
public class NotifyIntegrationEventHandlerImpl implements NotifyIntegrationEventHandler {

    private static final LoggerService logger = new LoggerService(LoggerFactory.getLogger(NotifyIntegrationEventHandlerImpl.class));

    private final OutboxService outboxService;

    @Autowired
    public NotifyIntegrationEventHandlerImpl(
            OutboxService outboxService) {
        this.outboxService = outboxService;
    }

    @Override
    public void handle(NotifyIntegrationEvent event) {
        OutboxIntegrationEvent message = new OutboxIntegrationEvent();
        message.setMessageId(UUID.randomUUID());
        message.setType(OutboxIntegrationEvent.NOTIFY);
        message.setEvent(event);
        this.outboxService.publish(message);
    }
}
