package eu.eudat.model.persist.dmpproperties;

import eu.eudat.commons.validation.BaseValidator;
import gr.cite.tools.validation.ValidatorFactory;
import gr.cite.tools.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import eu.eudat.model.persist.ReferencePersist;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

public class DmpBlueprintValuePersist {
    private UUID fieldId;

    public static final String _fieldId = "fieldId";
    private String fieldValue;
    public static final String _fieldValue = "fieldValue";
    private List<ReferencePersist> references;
    public static final String _references = "references";

    public UUID getFieldId() {
        return fieldId;
    }

    public void setFieldId(UUID fieldId) {
        this.fieldId = fieldId;
    }

    public String getFieldValue() {
        return fieldValue;
    }

    public void setFieldValue(String fieldValue) {
        this.fieldValue = fieldValue;
    }

    public List<ReferencePersist> getReferences() {
        return references;
    }

    public void setReferences(List<ReferencePersist> references) {
        this.references = references;
    }

    @Component(DmpBlueprintValuePersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class DmpBlueprintValuePersistValidator extends BaseValidator<DmpBlueprintValuePersist> {

        private final ValidatorFactory validatorFactory;
        private final MessageSource messageSource;

        public static final String ValidatorName = "DmpBlueprintValuePersistValidator";

        protected DmpBlueprintValuePersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, ValidatorFactory validatorFactory, MessageSource messageSource) {
            super(conventionService, errors);
            this.validatorFactory = validatorFactory;
	        this.messageSource = messageSource;
        }

        @Override
        protected Class<DmpBlueprintValuePersist> modelClass() {
            return DmpBlueprintValuePersist.class;
        }

        @Override
        protected List<Specification> specifications(DmpBlueprintValuePersist item) {
            return Arrays.asList(
//            this.spec()
//                    .must(() -> !this.isValidGuid(item.getFieldId()))
//                    .failOn(DmpBlueprintValuePersist._fieldId).failWith(messageSource.getMessage("Validation_Required", new Object[]{DmpBlueprintValuePersist._fieldId}, LocaleContextHolder.getLocale())),
//            this.spec()
//                    .iff(() -> this.isNull(item.getReferences()) || item.getReferences().isEmpty())
//                    .must(() -> !this.isEmpty(item.getFieldValue()))
//                    .failOn(DmpBlueprintValuePersist._fieldValue).failWith(messageSource.getMessage("Validation_Required", new Object[]{DmpBlueprintValuePersist._fieldValue}, LocaleContextHolder.getLocale())),
                   this.navSpec()
                            .iff(() -> !this.isListNullOrEmpty(item.getReferences()))
                            .on(DmpBlueprintValuePersist._references)
                            .over(item.getReferences())
                            .using((itm) -> this.validatorFactory.validator(ReferencePersist.ReferencePersistValidator.class))
            );
        }
    }

}
