import { Lookup } from "@common/model/lookup";
import { Guid } from "@common/types/guid";
import { IsActive } from "../common/enum/is-active.enum";
import { NotificationTemplateKind } from "../common/enum/notification-template-kind";
import { NotificationTemplateChannel } from "../common/enum/notification-template-channel";
import { NotificationType } from "../common/enum/notification-type";

export class NotificationTemplateLookup extends Lookup implements NotificationTemplateFilter {
	ids: Guid[];
	excludedIds: Guid[];
	isActive: IsActive[];
	kinds: NotificationTemplateKind[];
	channels: NotificationTemplateChannel[];
	notificationTypes: NotificationType[];

	constructor() {
		super();
	}
}

export interface NotificationTemplateFilter {
	ids: Guid[];
	excludedIds: Guid[];
	isActive: IsActive[];
	kinds: NotificationTemplateKind[];
	channels: NotificationTemplateChannel[];
	notificationTypes: NotificationType[];
}