import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { LoginComponent } from './login.component';
import { MergeEmailConfirmation } from './merge-email-confirmation/merge-email-confirmation.component';
import { UnlinkEmailConfirmation } from './unlink-email-confirmation/unlink-email-confirmation.component';

const routes: Routes = [
	{ path: '', component: LoginComponent },
	{ path: 'merge/confirmation/:token', component: MergeEmailConfirmation },
	{ path: 'unlink/confirmation/:token', component: UnlinkEmailConfirmation },
];

@NgModule({
	imports: [RouterModule.forChild(routes)],
	exports: [RouterModule]
})
export class LoginRoutingModule { }
